unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Menus,
  ExtCtrls, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    MainMenu1: TMainMenu;
    Memo1: TMemo;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioGroup1: TRadioGroup;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image2DblClick(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);
    procedure MenuItem4Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }
type policko=record
  x,y,riadok,stlpec:integer;
  kam:array[1..4] of integer;
  hrac:integer;
end;

var f,f2,f3,f4:text;
    a:array[0..24] of policko;
    surx,sury,z,z2,hrac1,hrac2:integer;
    polozene:integer;
    oznacene:boolean;
    lang:string;

procedure vykresli_policka;
var i:integer;
begin
  with Form1.Image1.Canvas do begin
                                   Pen.Width:=2;
                                   Pen.Style:=psSolid;
                                   Line(a[1].x,a[1].y,a[3].x,a[3].y);
                                   Line(a[4].x,a[4].y,a[6].x,a[6].y);
                                   Line(a[7].x,a[7].y,a[9].x,a[9].y);
                                   Line(a[10].x,a[10].y,a[12].x,a[12].y);
                                   Line(a[13].x,a[13].y,a[15].x,a[15].y);
                                   Line(a[16].x,a[16].y,a[18].x,a[18].y);
                                   Line(a[19].x,a[19].y,a[21].x,a[21].y);
                                   Line(a[22].x,a[22].y,a[24].x,a[24].y);
                                   Line(a[1].x,a[1].y,a[22].x,a[22].y);
                                   Line(a[4].x,a[4].y,a[19].x,a[19].y);
                                   Line(a[7].x,a[7].y,a[16].x,a[16].y);
                                   Line(a[2].x,a[2].y,a[8].x,a[8].y);
                                   Line(a[17].x,a[17].y,a[23].x,a[23].y);
                                   Line(a[9].x,a[9].y,a[18].x,a[18].y);
                                   Line(a[6].x,a[6].y,a[21].x,a[21].y);
                                   Line(a[3].x,a[3].y,a[24].x,a[24].y);
                                   Pen.Style:=psClear;
                              end;
  for i:=1 to 24 do with Form1.Image1.Canvas do begin
                                                    Brush.Color:=clBlack;
                                                    EllipseC(a[i].x,a[i].y,22,22);
                                                    Brush.Color:=clWhite;
                                                    EllipseC(a[i].x,a[i].y,20,20);
                                               end;
  Form1.Image1.Canvas.Pen.Width:=0;
  for i:=1 to 9 do with Form1.Image3.Canvas do begin
                                                    Brush.Color:=clBlue;
                                                    EllipseC(60,50*i,20,20);
                                                    Brush.Color:=clRed;
                                                    EllipseC(740,50*i,20,20);
                                               end;
end;

procedure nova_hra;
var i,j:integer;
begin
  Form1.Image2.Visible:=False;
  Form1.Image4.Visible:=False;
  Form1.Image5.Visible:=False;
  Form1.RadioGroup1.Visible:=False;
  Form1.Button1.Visible:=False;
  with Form1.Image1 do begin
                            Canvas.Pen.Style:=psClear;
                            Canvas.Brush.Color:=clWhite; {RgbToColor(255,252,130)}
                            Canvas.FillRect(ClientRect);
                       end;
  with Form1.Image3 do begin
                            Canvas.Pen.Style:=psClear;
                            Canvas.Brush.Color:=clWhite;
                            Canvas.FillRect(ClientRect);
                       end;
  Assign(f,'data.txt');
  Reset(f);
  for i:=1 to 24 do with a[i] do begin
                         Readln(f,x);
                         Readln(f,y);
                         Readln(f,riadok);
                         Readln(f,stlpec);
                         for j:=1 to 4 do Read(f,kam[j]);
                         hrac:=0;
                         Readln(f);
                    end;
  Close(f);
  vykresli_policka;
  polozene:=0;
  z:=0;
  a[0].hrac:=-1;
  hrac1:=9;
  hrac2:=9;
  oznacene:=False;
  case lang of
    'sk': Form1.Memo1.Text:='Modry: Poloz kamen.';
    'en': Form1.Memo1.Text:='Blue: Place a piece.';
    'de': Form1.Memo1.Text:='Blau: Setz einen Stein.';
  end;
end;

procedure vypis_napovedu;
var b:string;
    i:integer;
begin
  with Form1.Image2 do begin
                            Canvas.Brush.Color:=clWhite;
                            Canvas.FillRect(ClientRect);
                       end;
  Assign(f2,'napovedask.txt');
  Reset(f2);
  i:=0;
  Form1.Image2.Canvas.Font.Size:=10;
  while not(eof(f2)) do begin
                             Readln(f2,b);
                             Form1.Image2.Canvas.TextOut(1,16*i,b);
                             inc(i);
                        end;
  Close(f2);

  with Form1.Image4 do begin
                            Canvas.Brush.Color:=clWhite;
                            Canvas.FillRect(ClientRect);
                       end;
  Assign(f3,'napovedaen.txt');
  Reset(f3);
  i:=0;
  Form1.Image4.Canvas.Font.Size:=10;
  while not(eof(f3)) do begin
                             Readln(f3,b);
                             Form1.Image4.Canvas.TextOut(1,16*i,b);
                             inc(i);
                        end;
  Close(f3);

  with Form1.Image5 do begin
                            Canvas.Brush.Color:=clWhite;
                            Canvas.FillRect(ClientRect);
                       end;
  Assign(f4,'napovedade.txt');
  Reset(f4);
  i:=0;
  Form1.Image5.Canvas.Font.Size:=11;
  while not(eof(f4)) do begin
                             Readln(f4,b);
                             Form1.Image5.Canvas.TextOut(1,22*i,b);
                             inc(i);
                        end;
  Close(f4);
end;

procedure TForm1.MenuItem1Click(Sender: TObject);
begin
  nova_hra;
end;

procedure TForm1.MenuItem2Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.MenuItem3Click(Sender: TObject);
begin
  RadioGroup1.Visible:=False;
  Button1.Visible:=False;
  case lang of
    'sk': Image2.Visible:=True;
    'en': Image4.Visible:=True;
    'de': Image5.Visible:=True;
  end;
end;

procedure TForm1.MenuItem4Click(Sender: TObject);
begin
  RadioGroup1.Visible:=True;
  Button1.Visible:=True;
  Image2.Visible:=False;
  Image4.Visible:=False;
  Image5.Visible:=False;
end;

procedure TForm1.Image2DblClick(Sender: TObject);
begin
  Image2.Visible:=False;
  Image4.Visible:=False;
  Image5.Visible:=False;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if RadioButton1.Checked then lang:='sk';
  if RadioButton2.Checked then lang:='en';
  if RadioButton3.Checked then lang:='de';
  case lang of
    'sk': begin
               MenuItem1.Caption:='Nova Hra';
               MenuItem2.Caption:='Koniec Hry';
               MenuItem3.Caption:='Napoveda';
               MenuItem4.Caption:='Nastavenia';
               RadioGroup1.Caption:='Jazyk';
               Button1.Caption:='Zmenit jazyk';
               Form1.Caption:='Mlyn';
          end;
    'en': begin
               MenuItem1.Caption:='New Game';
               MenuItem2.Caption:='Exit';
               MenuItem3.Caption:='Help';
               MenuItem4.Caption:='Settings';
               RadioGroup1.Caption:='Language';
               Button1.Caption:='Change Language';
               Form1.Caption:='Mill';
          end;
    'de': begin
               MenuItem1.Caption:='Neu Spiel';
               MenuItem2.Caption:='Endspiel';
               MenuItem3.Caption:='Hilfe';
               MenuItem4.Caption:='Einstellungen';
               RadioGroup1.Caption:='Sprache';
               Button1.Caption:='Sprache wechseln';
               Form1.Caption:='Muhle';
          end;
  end;
  RadioGroup1.Visible:=False;
  Button1.Visible:=False;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Memo1.Lines.Clear;
  RadioGroup1.Visible:=False;
  Button1.Visible:=False;
  lang:='sk';
  nova_hra;
  vypis_napovedu;
end;

procedure poloz;
var i,nsurx,nsury:integer;
begin
  nsurx:=(surx div 80)+1;
  nsury:=(sury div 80)+1;
  for i:=1 to 24 do if (nsurx=(a[i].x div 80)+1) and (nsury=(a[i].y div 80)+1) then z:=i;
  if a[z].hrac=0 then begin
     if polozene mod 2 = 0 then
        begin
             Form1.Image1.Canvas.Brush.Color:=clBlue;
             Form1.Image1.Canvas.EllipseC(a[z].x,a[z].y,20,20);
             Form1.Image3.Canvas.Brush.Color:=clWhite;
             Form1.Image3.Canvas.EllipseC(60,50*((polozene div 2)+1),20,20);
             a[z].hrac:=1;
             case lang of
               'sk': Form1.Memo1.Text:='Cerveny: Poloz kamen.';
               'en': Form1.Memo1.Text:='Red: Place a piece.';
               'de': Form1.Memo1.Text:='Rot: Setz einen Stein.';
             end;
        end
                           else
        begin
             Form1.Image1.Canvas.Brush.Color:=clRed;
             Form1.Image1.Canvas.EllipseC(a[z].x,a[z].y,20,20);
             Form1.Image3.Canvas.Brush.Color:=clWhite;
             Form1.Image3.Canvas.EllipseC(740,50*((polozene div 2)+1),20,20);
             a[z].hrac:=2;
             if polozene<>17 then case lang of
                                    'sk': Form1.Memo1.Text:='Modry: Poloz kamen.';
                                    'en': Form1.Memo1.Text:='Blue: Place a piece.';
                                    'de': Form1.Memo1.Text:='Blau: Setz einen Stein.';
                                  end
                             else case lang of
                                    'sk': Form1.Memo1.Text:='Modry: Presun jeden zo svojich kamenov.';
                                    'en': Form1.Memo1.Text:='Blue: Move one of your pieces.';
                                    'de': Form1.Memo1.Text:='Blau: Beweg einen von deine Steine.';
                                  end;
        end;
     inc(polozene);
  end;
end;

procedure oznac;
var i,nsurx,nsury:integer;
begin
  nsurx:=(surx div 80)+1;
  nsury:=(sury div 80)+1;
  for i:=1 to 24 do if (nsurx=(a[i].x div 80)+1) and (nsury=(a[i].y div 80)+1) then z2:=i;
  if polozene mod 2 = 1 then
     begin
          if (a[z2].hrac=1) and (
             (a[a[z2].kam[1]].hrac=0) or
             (a[a[z2].kam[2]].hrac=0) or
             (a[a[z2].kam[3]].hrac=0) or
             (a[a[z2].kam[4]].hrac=0))
          then
             begin
                  Form1.Image1.Canvas.Brush.Color:=TColor($ff8000);
                  Form1.Image1.Canvas.EllipseC(a[z2].x,a[z2].y,20,20);
                  oznacene:=true;
             end
     end
          else
     begin
          if (a[z2].hrac=2) and (
             (a[a[z2].kam[1]].hrac=0) or
             (a[a[z2].kam[2]].hrac=0) or
             (a[a[z2].kam[3]].hrac=0) or
             (a[a[z2].kam[4]].hrac=0))
          then
             begin
                  Form1.Image1.Canvas.Brush.Color:=TColor($0080ff);
                  Form1.Image1.Canvas.EllipseC(a[z2].x,a[z2].y,20,20);
                  oznacene:=true;
             end;
     end;
end;

procedure presun;
var i,nsurx,nsury:integer;
begin
  nsurx:=(surx div 80)+1;
  nsury:=(sury div 80)+1;
  for i:=1 to 24 do if (nsurx=(a[i].x div 80)+1) and (nsury=(a[i].y div 80)+1) then z:=i;
  if polozene mod 2 = 1 then
     begin if a[z].hrac=1 then
       begin
            Form1.Image1.Canvas.Brush.Color:=clBlue;
            Form1.Image1.Canvas.EllipseC(a[z2].x,a[z2].y,20,20);
            oznacene:=False;
            oznac;
       end end
                        else
     if a[z].hrac=2 then
       begin
            Form1.Image1.Canvas.Brush.Color:=clRed;
            Form1.Image1.Canvas.EllipseC(a[z2].x,a[z2].y,20,20);
            oznacene:=False;
            oznac;
       end;
  if (a[z].hrac=0) and (
     (z=a[z2].kam[1]) or
     (z=a[z2].kam[2]) or
     (z=a[z2].kam[3]) or
     (z=a[z2].kam[4]))
  then begin
     if polozene mod 2 = 1 then
        begin
             Form1.Image1.Canvas.Brush.Color:=clBlue;
             Form1.Image1.Canvas.EllipseC(a[z].x,a[z].y,20,20);
             Form1.Image1.Canvas.Brush.Color:=clWhite;
             Form1.Image1.Canvas.EllipseC(a[z2].x,a[z2].y,20,20);
             a[z2].hrac:=0;
             a[z].hrac:=1;
             case lang of
               'sk': Form1.Memo1.Text:='Cerveny: Presun jeden zo svojich kamenov.';
               'en': Form1.Memo1.Text:='Red: Move one of your pieces.';
               'de': Form1.Memo1.Text:='Rot: Beweg einen von deine Steine.';
             end;
        end
                           else
        begin
             Form1.Image1.Canvas.Brush.Color:=clRed;
             Form1.Image1.Canvas.EllipseC(a[z].x,a[z].y,20,20);
             Form1.Image1.Canvas.Brush.Color:=clWhite;
             Form1.Image1.Canvas.EllipseC(a[z2].x,a[z2].y,20,20);
             a[z2].hrac:=0;
             a[z].hrac:=2;
             case lang of
               'sk': Form1.Memo1.Text:='Modry: Presun jeden zo svojich kamenov.';
               'en': Form1.Memo1.Text:='Blue: Move one of your pieces.';
               'de': Form1.Memo1.Text:='Blau: Beweg einen von deine Steine.';
             end;
        end;
     inc(polozene);
     oznacene:=False;
  end;
end;

procedure odstran(indexhraca:integer);
var i,nsurx,nsury,z1:integer;
begin
  nsurx:=(surx div 80)+1;
  nsury:=(sury div 80)+1;
  for i:=1 to 24 do if (nsurx=(a[i].x div 80)+1) and (nsury=(a[i].y div 80)+1) then z1:=i;
  if (nsurx>0) and (nsurx<8) then {vyhodi zacyklenu chybu, ked klikne mimo hracej plochy}
   if a[z1].hrac=indexhraca then
     begin
          a[z1].hrac:=0;
          Form1.Image1.Canvas.Brush.Color:=clWhite;
          Form1.Image1.Canvas.EllipseC(a[z1].x,a[z1].y,20,20);
          z:=0;
          if polozene<18 then
             if indexhraca=1 then begin
                                       dec(hrac1);
                                       case lang of
                                         'sk': Form1.Memo1.Text:='Modry: Poloz kamen.';
                                         'en': Form1.Memo1.Text:='Blue: Place a piece.';
                                         'de': Form1.Memo1.Text:='Blau: Setz einen Stein.';
                                       end;
                                  end
                             else begin
                                       dec(hrac2);
                                       case lang of
                                         'sk': Form1.Memo1.Text:='Cerveny: Poloz kamen.';
                                         'en': Form1.Memo1.Text:='Red: Place a piece.';
                                         'de': Form1.Memo1.Text:='Rot: Setz einen Stein.';
                                       end;
                                  end
                         else
             if indexhraca=1 then begin
                                       dec(hrac1);
                                       case lang of
                                         'sk': Form1.Memo1.Text:='Modry: Presun jeden zo svojich kamenov.';
                                         'en': Form1.Memo1.Text:='Blue: Move one of your pieces.';
                                         'de': Form1.Memo1.Text:='Blau: Beweg einen von deine Steine.';
                                       end;
                                  end
                             else begin
                                       dec(hrac2);
                                       case lang of
                                         'sk': Form1.Memo1.Text:='Cerveny: Presun jeden zo svojich kamenov.';
                                         'en': Form1.Memo1.Text:='Red: Move one of your pieces.';
                                         'de': Form1.Memo1.Text:='Rot: Beweg einen von deine Steine.';
                                       end;
                                  end;
     end;
end;

function jeMlyn:integer;
var i,j,k:integer;
begin
  jeMlyn:=0;
  j:=0;
  k:=0;
  for i:=1 to 24 do
      begin
           if a[i].riadok=a[z].riadok then if a[i].hrac=a[z].hrac then inc(j);
           if a[i].stlpec=a[z].stlpec then if a[i].hrac=a[z].hrac then inc(k);
      end;
  if (j=3) or (k=3) then if a[z].hrac=2 then jeMlyn:=2
                                        else jeMlyn:=1;
end;

function jeKoniecHry:integer;
var i,hrac1a,hrac2a:integer;
begin
  hrac1a:=0;
  hrac2a:=0;
  jeKoniecHry:=0;
  for i:=1 to 24 do
      begin
           if (a[i].hrac=1) and (
              (a[a[i].kam[1]].hrac<>0) and
              (a[a[i].kam[2]].hrac<>0) and
              (a[a[i].kam[3]].hrac<>0) and
              (a[a[i].kam[4]].hrac<>0))
           then inc(hrac1a);
           if (a[i].hrac=2) and (
              (a[a[i].kam[1]].hrac<>0) and
              (a[a[i].kam[2]].hrac<>0) and
              (a[a[i].kam[3]].hrac<>0) and
              (a[a[i].kam[4]].hrac<>0))
           then inc(hrac2a);
      end;
  if hrac1-hrac1a=0 then jeKoniecHry:=1;
  if hrac2-hrac2a=0 then jeKoniecHry:=2;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
    Shift: TShiftState; X, Y: Integer);
begin
  RadioGroup1.Visible:=False;
  Button1.Visible:=False;

  surx:=x;
  sury:=y;
  if (polozene<18) and (jeMlyn=0) then poloz;
  if (polozene>18) and (jeMlyn=0) and (oznacene=False) then oznac;
  if oznacene then presun;
  if polozene=18 then inc(polozene);
  if (jeMlyn<>0) and (oznacene=False) then
     if jeMlyn=2 then begin
                           case lang of
                             'sk': Form1.Memo1.Text:='Cerveny: Mlyn, vyber 1 modry kamen na odstranenie.';
                             'en': Form1.Memo1.Text:='Red: Mill, choose 1 blue piece to delete.';
                             'de': Form1.Memo1.Text:='Rot: Muhle, wahle 1 blau Stein aus, auszunehmen.';
                           end;
                           odstran(1);
                      end
                 else begin
                           case lang of
                             'sk': Form1.Memo1.Text:='Modry: Mlyn, vyber 1 cerveny kamen na odstranenie.';
                             'en': Form1.Memo1.Text:='Blue: Mill, choose 1 red piece to delete.';
                             'de': Form1.Memo1.Text:='Blau: Muhle, wahle 1 rot Stein aus, auszunehmen.';
                           end;
                           odstran(2);
                      end;
  if (hrac1<3) or (jeKoniecHry=1) then
    begin
         case lang of
           'sk': begin
                      Memo1.Text:='Koniec hry. Vyhral CERVENY.';
                      ShowMessage('Koniec hry. Vyhral CERVENY.');
                 end;
           'en': begin
                      Memo1.Text:='Game over. RED won.';
                      ShowMessage('Game over. RED won.');
                 end;
           'de': begin
                      Memo1.Text:='Spielende. ROT siegte.';
                      ShowMessage('Spielende. ROT siegte.');
                 end;
         end;
    end;
  if (hrac2<3) or (jeKoniecHry=2) then
    begin
         case lang of
           'sk': begin
                      Memo1.Text:='Koniec hry. Vyhral MODRY.';
                      ShowMessage('Koniec hry. Vyhral MODRY.');
                 end;
           'en': begin
                      Memo1.Text:='Game over. BLUE won.';
                      ShowMessage('Game over. BLUE won.');
                 end;
           'de': begin
                      Memo1.Text:='Spielende. BLAU siegte.';
                      ShowMessage('Spielende. BLAU siegte.');
                 end;
         end;
    end;
end;

end.
